=begin
#Platform external API.

#Documentation of our Platform external API.

OpenAPI spec version: 1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 3.0.34
=end

module Shippo
  class RatesApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Retrieve shipment rates in currency
    # Each valid shipment object will automatically trigger the calculation of all available rates. Depending on your shipment data, there may be none, one or multiple rates.  By default, the calculated Rates will return the price in two currencies under the amount and amount_local keys, respectively. The amount key will contain the price of a rate expressed in the currency that is used in the country from which parcel originates, and the amount_local key will contain the price expressed in the currency that is used in the country the parcel is shipped to. You can request rates with prices expressed in a different currency by adding the desired currency code in the end of the resource URL. The full list of supported currencies along with their codes can be viewed on [open exchange rates](http://openexchangerates.org/api/currencies.json).  Note: re-requesting the rates with a different currency code will re-queue the shipment (i.e. set the Shipment's status to QUEUED) and the converted currency rates will only be available when the Shipment's status is set to SUCCESS.
    # @param merchant_id description: Object ID of the merchant
    # @param currency_code description: ISO currency code for the rates
    # @param shipment_id description: Object ID of the shipment to update
    # @param [Hash] opts the optional parameters
    # @option opts [String] :shippo_api_version description: String used to pick a non-default api version to use
    # @option opts [Integer] :page description: The page number you want to select (default to 1)
    # @option opts [Integer] :results description: The number of results to return per page (max 100) (default to 25)
    # @return [PaginatedRateResponse]
    def list_shipment_rates_cc(merchant_id, currency_code, shipment_id, opts = {})
      data, _status_code, _headers = list_shipment_rates_cc_with_http_info(merchant_id, currency_code, shipment_id, opts)
      data
    end

    # Retrieve shipment rates in currency
    # Each valid shipment object will automatically trigger the calculation of all available rates. Depending on your shipment data, there may be none, one or multiple rates.  By default, the calculated Rates will return the price in two currencies under the amount and amount_local keys, respectively. The amount key will contain the price of a rate expressed in the currency that is used in the country from which parcel originates, and the amount_local key will contain the price expressed in the currency that is used in the country the parcel is shipped to. You can request rates with prices expressed in a different currency by adding the desired currency code in the end of the resource URL. The full list of supported currencies along with their codes can be viewed on [open exchange rates](http://openexchangerates.org/api/currencies.json).  Note: re-requesting the rates with a different currency code will re-queue the shipment (i.e. set the Shipment&#x27;s status to QUEUED) and the converted currency rates will only be available when the Shipment&#x27;s status is set to SUCCESS.
    # @param merchant_id description: Object ID of the merchant
    # @param currency_code description: ISO currency code for the rates
    # @param shipment_id description: Object ID of the shipment to update
    # @param [Hash] opts the optional parameters
    # @option opts [String] :shippo_api_version description: String used to pick a non-default api version to use
    # @option opts [Integer] :page description: The page number you want to select
    # @option opts [Integer] :results description: The number of results to return per page (max 100)
    # @return [Array<(PaginatedRateResponse, Integer, Hash)>] PaginatedRateResponse data, response status code and response headers
    def list_shipment_rates_cc_with_http_info(merchant_id, currency_code, shipment_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RatesApi.list_shipment_rates_cc ...'
      end
      # verify the required parameter 'merchant_id' is set
      if @api_client.config.client_side_validation && merchant_id.nil?
        fail ArgumentError, "Missing the required parameter 'merchant_id' when calling RatesApi.list_shipment_rates_cc"
      end
      # verify the required parameter 'currency_code' is set
      if @api_client.config.client_side_validation && currency_code.nil?
        fail ArgumentError, "Missing the required parameter 'currency_code' when calling RatesApi.list_shipment_rates_cc"
      end
      # verify the required parameter 'shipment_id' is set
      if @api_client.config.client_side_validation && shipment_id.nil?
        fail ArgumentError, "Missing the required parameter 'shipment_id' when calling RatesApi.list_shipment_rates_cc"
      end
      # resource path
      local_var_path = '/merchants/{MerchantId}/shipments/{ShipmentId}/rates/{CurrencyCode}/'.sub('{' + 'MerchantId' + '}', merchant_id.to_s).sub('{' + 'CurrencyCode' + '}', currency_code.to_s).sub('{' + 'ShipmentId' + '}', shipment_id.to_s)

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'page'] = opts[:'page'] if !opts[:'page'].nil?
      query_params[:'results'] = opts[:'results'] if !opts[:'results'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      header_params[:'SHIPPO-API-VERSION'] = opts[:'shippo_api_version'] if !opts[:'shippo_api_version'].nil?

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      return_type = opts[:return_type] || 'PaginatedRateResponse' 

      auth_names = opts[:auth_names] || ['APIKeyHeader']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RatesApi#list_shipment_rates_cc\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Retrieve shipment rates
    # Gets a paginated list of rates associated with a shipment
    # @param merchant_id description: Object ID of the merchant
    # @param shipment_id description: Object ID of the shipment to update
    # @param [Hash] opts the optional parameters
    # @option opts [String] :shippo_api_version description: String used to pick a non-default api version to use
    # @option opts [Integer] :page description: The page number you want to select (default to 1)
    # @option opts [Integer] :results description: The number of results to return per page (max 100) (default to 25)
    # @return [PaginatedRateResponse]
    def list_shipment_rates(merchant_id, shipment_id, opts = {})
      data, _status_code, _headers = list_shipment_rates_with_http_info(merchant_id, shipment_id, opts)
      data
    end

    # Retrieve shipment rates
    # Gets a paginated list of rates associated with a shipment
    # @param merchant_id description: Object ID of the merchant
    # @param shipment_id description: Object ID of the shipment to update
    # @param [Hash] opts the optional parameters
    # @option opts [String] :shippo_api_version description: String used to pick a non-default api version to use
    # @option opts [Integer] :page description: The page number you want to select
    # @option opts [Integer] :results description: The number of results to return per page (max 100)
    # @return [Array<(PaginatedRateResponse, Integer, Hash)>] PaginatedRateResponse data, response status code and response headers
    def list_shipment_rates_with_http_info(merchant_id, shipment_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RatesApi.list_shipment_rates ...'
      end
      # verify the required parameter 'merchant_id' is set
      if @api_client.config.client_side_validation && merchant_id.nil?
        fail ArgumentError, "Missing the required parameter 'merchant_id' when calling RatesApi.list_shipment_rates"
      end
      # verify the required parameter 'shipment_id' is set
      if @api_client.config.client_side_validation && shipment_id.nil?
        fail ArgumentError, "Missing the required parameter 'shipment_id' when calling RatesApi.list_shipment_rates"
      end
      # resource path
      local_var_path = '/merchants/{MerchantId}/shipments/{ShipmentId}/rates/{CurrencyCode}'.sub('{' + 'MerchantId' + '}', merchant_id.to_s).sub('{' + 'ShipmentId' + '}', shipment_id.to_s)

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'page'] = opts[:'page'] if !opts[:'page'].nil?
      query_params[:'results'] = opts[:'results'] if !opts[:'results'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      header_params[:'SHIPPO-API-VERSION'] = opts[:'shippo_api_version'] if !opts[:'shippo_api_version'].nil?

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      return_type = opts[:return_type] || 'PaginatedRateResponse' 

      auth_names = opts[:auth_names] || ['APIKeyHeader']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RatesApi#list_shipment_rates\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Retrieve a rate
    # Retrieve an existing rate by object id for the merchant
    # @param merchant_id description: Object ID of the merchant
    # @param rate_id description: Object ID of the rate
    # @param [Hash] opts the optional parameters
    # @option opts [String] :shippo_api_version description: String used to pick a non-default api version to use
    # @return [Rate]
    def get_rate(merchant_id, rate_id, opts = {})
      data, _status_code, _headers = get_rate_with_http_info(merchant_id, rate_id, opts)
      data
    end

    # Retrieve a rate
    # Retrieve an existing rate by object id for the merchant
    # @param merchant_id description: Object ID of the merchant
    # @param rate_id description: Object ID of the rate
    # @param [Hash] opts the optional parameters
    # @option opts [String] :shippo_api_version description: String used to pick a non-default api version to use
    # @return [Array<(Rate, Integer, Hash)>] Rate data, response status code and response headers
    def get_rate_with_http_info(merchant_id, rate_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RatesApi.get_rate ...'
      end
      # verify the required parameter 'merchant_id' is set
      if @api_client.config.client_side_validation && merchant_id.nil?
        fail ArgumentError, "Missing the required parameter 'merchant_id' when calling RatesApi.get_rate"
      end
      # verify the required parameter 'rate_id' is set
      if @api_client.config.client_side_validation && rate_id.nil?
        fail ArgumentError, "Missing the required parameter 'rate_id' when calling RatesApi.get_rate"
      end
      # resource path
      local_var_path = '/merchants/{MerchantId}/rates/{RateId}/'.sub('{' + 'MerchantId' + '}', merchant_id.to_s).sub('{' + 'RateId' + '}', rate_id.to_s)

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      header_params[:'SHIPPO-API-VERSION'] = opts[:'shippo_api_version'] if !opts[:'shippo_api_version'].nil?

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      return_type = opts[:return_type] || 'Rate' 

      auth_names = opts[:auth_names] || ['APIKeyHeader']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RatesApi#get_rate\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
